# Building Casio_asm
Building Casio_asm is not as easy as I want it to be, due to my poor organization.  
To build Casio_asm, the first thing to do is to execute `make` in the `data` directory. This will generate a lot of source files auto-magically based on the contents of `opcode.list` and `decoder.list`.
Then the building process depends on the target platform.

## Building for Casio
First, make sure to have a SH3 toolchain in your path with `sh3eb-elf-` as prefix.  
Then, go into the `CASIO_fxlib` directory and execute these commands:  
`make fetch`: copy sources from different parts of the repo.  
`make`: build the damn thing.  
Optionally, if you have `p7` installed and in your path, you can use `make send` to upload the add-in to the calculator.

## Building for PC
First, go into `common` and execute `make`.  
Then, go into `assembler` and execute `make`.  
And finally, go into `interpreter` and execute `make`.

## Cleaning up
The `clean` rule exists for all directories except `data`.  
The `clean` rule removes all object files, but also the output executable.
