#ifndef LINKER_H
#define LINKER_H

#include "../common/sourceFile.h"
#include "../common/string.h"
#include "proc.h"
#include "mmu.h"
#include "segments.h"

int Linker_link(string filename, proc_t *proc);

#define LINKER_ERR_NOOPEN 1
#define LINKER_ERR_READ 2
#define LINKER_ERR_COMPAT 3
#define LINKER_ERR_MAP_RAM 4
#define LINKER_ERR_MAP_FILE 5
#define LINKER_ERR_MAP_ROM 6
#define LINKER_ERR_MAP_STACK 7
#define LINKER_ERR_DUPROM 8
#define LINKER_ERR_MAP_VRAM 9

#endif
