#ifndef OPCODE_LIST
#define OPCODE_LIST

void Opcode_registerOpcodes();

#define OP_nop 0
#define OP_add_i 1
#define OP_sub_i 2
#define OP_mul_i 3
#define OP_div_i 4
#define OP_mod_i 5
#define OP_neg_i 6
#define OP_shlt 7
#define OP_shrt 8
#define OP_and 9
#define OP_or 10
#define OP_xor 11
#define OP_not 12
#define OP_and_l 13
#define OP_or_l 14
#define OP_xor_l 15
#define OP_not_l 16
#define OP_is_l 17
#define OP_lt_i 18
#define OP_le_i 19
#define OP_gt_i 20
#define OP_ge_i 21
#define OP_eq_i 22
#define OP_neq_i 23
#define OP_push 24
#define OP_dup 25
#define OP_pop 26
#define OP_swap 27
#define OP_high 28
#define OP_top 29
#define OP_jmp 30
#define OP_jif 31
#define OP_jnt 32
#define OP_jind 33
#define OP_call 34
#define OP_cif 35
#define OP_cnt 36
#define OP_store 37
#define OP_stind 38
#define OP_puind 39
#define OP_swreg 40
#define OP_swregi 41
#define OP_halt 42
#define OP_reset 43
#define OP_int 44
#define OP_inth 45
#define OP_sub 46
#define OP_unsub 47
#define OP_stat_g 48
#define OP_stat_s 49
#define OP_stat 50
#define OP_ext 51
#define OP_mem_wr 52
#define OP_mem_ww 53
#define OP_mem_hr 54
#define OP_mem_hw 55
#define OP_mem_br 56
#define OP_mem_bw 57
#define OP_lastad 58
#define OP_extend 63
#define OP_E_nop 0
#define OP_E_add_d 1
#define OP_E_sub_d 2
#define OP_E_mul_d 3
#define OP_E_div_d 4
#define OP_E_pow_d 5
#define OP_E_neg_d 6
#define OP_E_sqrt 7
#define OP_E_cbrt 8
#define OP_E_hypot 9
#define OP_E_exp 10
#define OP_E_ln 11
#define OP_E_floor 12
#define OP_E_ceil 13
#define OP_E_round 14
#define OP_E_cos 15
#define OP_E_sin 16
#define OP_E_tan 17
#define OP_E_atan 18
#define OP_E_atan2 19
#define OP_E_lt_d 20
#define OP_E_le_d 21
#define OP_E_gt_d 22
#define OP_E_ge_d 23
#define OP_E_eq_d 24
#define OP_E_neq_d 25
#define OP_E_i2d 26
#define OP_E_d2i 27
#define OP_E_cst_pi 28
#define OP_E_cst_e 29

#define OPCODE_COUNT 60
#define OPCODE_EXT_COUNT 30
#define OPCODE_NAME_LEN 7
#define OPCODE_DESC_LEN 74

#endif
