#ifndef STRING_H
#define STRING_H

typedef char* string;

//fixed length functions
void strcpyl(string src, string dest, int max);
int strcmpl(string src, string cmp, int max);
int strsuml(string str, int max);
int strlenl(string str, int max);

//null-terminated functions
void strcpyd(string src, string dest);
int strcmpd(string src, string cmp);
int strsumd(string str);
int strlend(string str);

//char-terminated functions
void strcpyt(string src, string dest, char end);
int strcmpt(string src, string cmp, char end);
int strsumt(string str, char end);
int strlent(string str, char end);

//int to string conversion
string itohex(int val, int digits);
string itobin(int val, int digits);
string itodec(int val);

//string to int conversion
int hextoi(string str);
int dectoi(string str);
int bintoi(string str);

#endif
