# Casio_asm
This project is a collection of programs with a two goals in mind: running an assembled language on calculator as well as on PC, and assembling it on both platform with bytecode compatibility.  
This program consists of two main parts: an [interpreter][interpreter] and an [assembler][assembler].

## The interpreter
The [interpreter][interpreter] is a program that runs on both PC and CASIO and executes  [bytecode files][bin_file] faster than CASIO BASIC.

## The assembler
The [assembler][assembler] is a program destined to run on the calculator as well as on PC. This program takes as input an [assembler file][asm_file] and optionally a [config file][cfg_file] and outputs a [bytecode file][bin_file].

[interpreter]: ./interpreter.md
[assembler]: ./assembler.md
[bin_file]: ./bin_file.md
[asm_file]: ./asm_file.md
[cfg_file]: ./cfg_file.md
