#ifndef DECODER_IMP_H
#define DECODER_IMP_H

#include "proc.h"
#include "../common/opcode.h"

#include "stack.h"

void decodeInstructionImp(proc_t *proc, opcode_t *op, opcode_data_t *instruction, char mode);
void decodeInstructionExtImp(proc_t *proc, opcode_ext_t *op, opcode_data_t *instruction, char mode);

#define RULE_2d 0
#define RULE_2s 1
#define RULE_1d 2
#define RULE_1 3
#define RULE_0 4
#define RULE_2 5

#endif
